-- Common imports.
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Animation";
import "Turbine.UI.Extensions";


-- comment the load
Turbine.Shell.WriteLine("Moralebar v1.0.0 by ROCKsPlugins")

-- get resolution
screenWidth, screenHeight = Turbine.UI.Display:GetSize();

-- constant window, parameter
width = 500
height = 40
opacity = 0.2
function heightfromground(height)
heightfromground = height
end
heightfromground = 200
heightfromgroundTarget = heightfromground + height + 10
startTime = 0;

-- Background for label
Background = "ROCKsPlugins/Moralbar/Resources/Verlauf.tga"
Background2 = "ROCKsPlugins/Moralbar/Resources/Verlauf2.tga"
Background3 = "ROCKsPlugins/Moralbar/Resources/Verlauf3.tga"

-- actor vitalbar
window = Turbine.UI.Window();
window:SetPosition(screenWidth/2 - width/2, screenHeight - height - heightfromground);
window:SetSize(width, height);
window:SetVisible(true);
window:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));
window:SetZOrder(-1);
window:SetBackground(Background);
window:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );


-- morale label
label1 = Turbine.UI.Label();
label1:SetParent(window);
label1:SetSize(width, height);
label1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
label1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
label1:SetOutlineColor(Turbine.UI.Color(opacity, 0, 0, 0));
label1:SetFontStyle( Turbine.UI.FontStyle.Outline )
label1:SetFont( Turbine.UI.Lotro.Font.Verdana20 )


-- percent label
label2 = Turbine.UI.Label()
label2:SetParent(window);
label2:SetSize(width, height);
label2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
label2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
label2:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));


-- + label
label3 = Turbine.UI.Label()
label3:SetParent(window);
label3:SetSize(width, height);
label3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
label3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
label3:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
label3:SetFontStyle( Turbine.UI.FontStyle.Outline )
label3:SetFont( Turbine.UI.Lotro.Font.Verdana16 )


-- morale change label
label4 = Turbine.UI.Label()
label4:SetParent(window);
label4:SetVisible(false);
label4:SetSize(width, height);
label4:SetBackColor(Turbine.UI.Color(1, 1, 0, 0));
label4:SetZOrder(-1);
label4:SetBackground(Background2);
label4:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );


-- hit label, delta between two hits
widthLast = width;

label5 = Turbine.UI.Label()
label5:SetParent(window);
label5:SetVisible(false);
label5:SetSize(widthLast, height);
label5:SetBackColor(Turbine.UI.Color(1, 1, 1, 1));
label5:SetZOrder(-2);


-- load LocalPlayer
player = Turbine.Gameplay.LocalPlayer.GetInstance()
local maxMorale = math.floor(player:GetMaxMorale());


-- Start Print
label1:SetText(maxMorale);
label2:SetText("100 % ");
label3:SetText(" +"); 


-- routine by morale change
player.MoraleChanged = function (sender, args)
    -- get actualy morale
    local actuMorale = math.floor(player:GetMorale());

    -- get max. Morale
    local maxMorale = math.floor(player:GetMaxMorale());

    -- Morale in percent
    local percentMorale = math.floor((actuMorale / maxMorale * 100));

    
    -- display Morale
    if percentMorale == 100 then
        label1:SetText(maxMorale);
        -- set label visibility
        label4:SetVisible(false); -- visible
        label5:SetVisible(false); -- visible
        -- opaticity change from text labels
        label1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        label2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        label3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        window:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));

    else
        label1:SetText(actuMorale .. " / " .. maxMorale);
        -- set label visibility
        label4:SetVisible(true); -- visible
        label5:SetVisible(true); -- visible
        -- opaticity change from text labels
        label1:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        label2:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        label3:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        window:SetBackColor(Turbine.UI.Color(0.8, 0, 0, 0));
        window:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend );
        -- set remain morale label
        local widthChange = width * percentMorale / 100;
        label4:SetSize(widthChange, height);

        -- width change for morale between two hits
        local widthDelta = widthLast - widthChange;
        widthLast = widthLast - widthDelta;
        label5:SetSize((widthLast + widthDelta), height);
        label5:SetWantsUpdates(true);
        

        label5.Update = function (sender, args)
            -- delay realize, smooth delta morale reduce
            local currentTime = math.floor(Turbine.Engine.GetGameTime()); -- in seconds
            if (startTime > currentTime) then

            -- Reduce the hit label width           
            widthDelta = widthDelta - 1;
            label5:SetSize((widthLast + widthDelta), height);
            if widthDelta == 0 then label5:SetWantsUpdates(false); end
            end
        startTime = currentTime + 1;
        
        end
        --label5:SetWantsUpdates(false);
    end

    --display percent Morale
    label2:SetText(percentMorale .. " % ");
 
end 


-- routine by max morale change
player.MaxMoraleChanged = function (sender, args)
    -- get actualy morale
    local actuMorale = math.floor(player:GetMorale());

    -- get max. Morale
    local maxMorale = math.floor(player:GetMaxMorale());

    -- Morale in percent
    local percentMorale = math.floor((actuMorale / maxMorale * 100));

    -- display Morale
    if percentMorale == 100 then
        label1:SetText(maxMorale);
        -- set label visibility
        label4:SetVisible(false); -- visible
        label5:SetVisible(false); -- visible
        -- opaticity change from text labels
        label1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        label2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        label3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        window:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));

    else
        label1:SetText(actuMorale .. " / " .. maxMorale);
        -- set label visibility
        label4:SetVisible(true); -- visible
        label5:SetVisible(true); -- visible
        -- opaticity change from text labels
        label1:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        label2:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        label3:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        window:SetBackColor(Turbine.UI.Color(0.8, 0, 0, 0));
        window:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend );
        -- width change for label, morale change label continue, 100 % = width (max 500), 0 % = width (min 0)
        local widthChange = width * percentMorale / 100;
        label4:SetSize(widthChange, height);
        -- width change for morale between two hits
        label5:SetSize(widthLast, height);
        local widthDelta = widthLast - widthChange;
        widthLast = widthLast - widthDelta;
    end

    --display percent Morale
    label2:SetText(percentMorale .. " % ");
 
end

-----------------------------------------------------------------------------
function spaeter()
    ---- actor vitalbar
    --targetWindow = Turbine.UI.Window();
    --targetWindow:SetPosition(screenWidth/2 - width/2, screenHeight - height - heightfromgroundTarget);
    --targetWindow:SetSize(width, height);
    --targetWindow:SetVisible(false);
    --targetWindow:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));
    --targetWindow:SetZOrder(-1);
    --targetWindow:SetBackground(Background);
    --targetWindow:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );
    --
    --
    ---- morale label
    --labelTarget1 = Turbine.UI.Label();
    --labelTarget1:SetParent(targetWindow);
    --labelTarget1:SetVisible(false);
    --labelTarget1:SetSize(width, height);
    --labelTarget1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
    --labelTarget1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
    --labelTarget1:SetOutlineColor(Turbine.UI.Color(opacity, 0, 0, 0));
    --labelTarget1:SetFontStyle( Turbine.UI.FontStyle.Outline )
    --labelTarget1:SetFont( Turbine.UI.Lotro.Font.Verdana20 )
    --
    --
    ---- percent label
    --labelTarget2 = Turbine.UI.Label()
    --labelTarget2:SetParent(targetWindow);
    --labelTarget2:SetVisible(false);
    --labelTarget2:SetSize(width, height);
    --labelTarget2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
    --labelTarget2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
    --labelTarget2:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
    --
    --
    ---- + label
    --labelTarget3 = Turbine.UI.Label()
    --labelTarget3:SetParent(targetWindow);
    --labelTarget3:SetVisible(false);
    --labelTarget3:SetSize(width, height);
    --labelTarget3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
    --labelTarget3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
    --labelTarget3:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
    --labelTarget3:SetFontStyle( Turbine.UI.FontStyle.Outline )
    --labelTarget3:SetFont( Turbine.UI.Lotro.Font.Verdana16 )
    --
    --
    ---- morale change label
    --labelTarget4 = Turbine.UI.Label()
    --labelTarget4:SetParent(targetWindow);
    --labelTarget4:SetVisible(false);
    --labelTarget4:SetSize(width, height);
    --labelTarget4:SetBackColor(Turbine.UI.Color(1, 1, 0, 0));
    --labelTarget4:SetZOrder(-1);
    --labelTarget4:SetBackground(Background2);
    --labelTarget4:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );
    --
    --
    ---- hit label, delta between two hits
    --widthLastTar = width;
    --startTimeTar = 0;
    --
    --labelTarget5 = Turbine.UI.Label()
    --labelTarget5:SetParent(targetWindow);
    --labelTarget5:SetVisible(false);
    --labelTarget5:SetSize(widthLast, height);
    --labelTarget5:SetBackColor(Turbine.UI.Color(1, 1, 1, 1));
    --labelTarget5:SetZOrder(-2);
    --
    --
    ----player = Turbine.Gameplay.LocalPlayer.GetInstance()
    --
    --    
    --player.TargetChanged = function (sender, args)
    --    target = player:GetTarget();
    --    if target ~= nil then
    --        local targetName = target:GetName();
    --        local targetMorale = math.floor(target:GetMorale());
    --        local targetMaxMorale = math.floor(target:GetMaxMorale());
    --        -- Morale in percent
    --        local targetpercentMorale = math.floor((targetMorale / targetMaxMorale * 100));
    --
    --        
    --        targetWindow:SetVisible(true);
    --        labelTarget1:SetVisible(true);
    --        labelTarget2:SetVisible(true);
    --        labelTarget3:SetVisible(true);
    --
    --        --target:SetWantsUpdates(true);
    --        labelTarget1:SetText(targetMaxMorale);
    --
    --    else
    --        targetWindow:SetVisible(false);
    --        labelTarget1:SetVisible(false);
    --        labelTarget2:SetVisible(false);
    --        labelTarget3:SetVisible(false);
    --        labelTarget4:SetVisible(false);
    --        --target:SetWantsUpdates(false);
    --        
    --    end
    --end
    --
    --
    ---- Start Print
    --labelTarget2:SetText("100 % ");
    --labelTarget3:SetText(" +"); 
    --
    
    
    --if targetpercentMorale == 100 then
    --    labelTarget1:SetText(targetMaxMorale);
    --    -- set label visibility
    --    labelTarget4:SetVisible(false); -- visible
    --    labelTarget5:SetVisible(false); -- visible
    --    -- opaticity change from text labels
    --    labelTarget1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
    --    labelTarget2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
    --    labelTarget3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
    --    targetWindow:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));
    --else
    --    labelTarget1:SetText(targetMorale .. " / " .. targetMaxMorale);
    --    -- set label visibility
    --    labelTarget4:SetVisible(true); -- visible
    --    labelTarget5:SetVisible(true); -- visible
    --    -- opaticity change from text labels
    --    labelTarget1:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
    --    labelTarget2:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
    --    labelTarget3:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
    --    targetWindow:SetBackColor(Turbine.UI.Color(0.8, 0, 0, 0));
    --    targetWindow:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend );
    --    -- set remain morale label
    --    local widthChangeTar = width * targetpercentMorale / 100;
    --    labelTarget4:SetSize(widthChange, height);
    --    -- width change for morale between two hits
    --    local widthDeltaTar = widthLastTar - widthChangeTar;
    --    widthLastTar = widthLastTar - widthDeltaTar;
    --    labelTarget5:SetSize((widthLast + widthDeltaTar), height);
    --    labelTarget5:SetWantsUpdates(true);
    --
    --    labelTarget5.Update = function (sender, args)
    --        -- delay realize, smooth delta morale reduce
    --        local currentTimeTar = math.floor(Turbine.Engine.GetGameTime()); -- in seconds
    --        if (startTimeTar > currentTimeTar) then
    --            -- Reduce the hit label width           
    --            widthDeltaTar = widthDeltaTar - 1;
    --            labelTarget5:SetSize((widthLastTar + widthDeltaTar), height);
    --            if widthDeltaTar == 0 then labelTarget5:SetWantsUpdates(false); end
    --        end
    --    startTimeTar = currentTimeTar + 1;
    --
    --    end
    --    labelTarget5:SetWantsUpdates(false);
    --end
    --display percent Morale
    --labelTarget2:SetText(targetpercentMorale .. " % ");

end
-----------------------------------------------------------------------------

function DrawOptionsControl()
    options = Turbine.UI.Control();
    plugin.GetOptionsPanel = function(self) return options; end

    options:SetBackColor(Turbine.UI.Color(0.1, 0.1, 0.1)); -- RGB, 0 = 0, 1 = 255.
    options:SetSize(250, 200);

    -- add a label for load/unload original vitalbar
    local vitalLabel = Turbine.UI.Label();
    vitalLabel:SetParent(options);
    vitalLabel:SetSize(300, 25);
    vitalLabel:SetPosition(10, 10);
    vitalLabel:SetText("Moralebar Switch: On/Off/Auto/AutoInvert");

    local vitalButton = Turbine.UI.Lotro.Button()
    vitalButton:SetParent(options);
    vitalButton:SetSize(30, 15);
    vitalButton:SetPosition(10, 30);
    vitalButton:SetVisible(true);
    vitalButton:SetText("On");
    local i = 0;
    vitalButton.Click = function(sender, args)
        if i == 0 then
            Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, false );
            vitalButton:SetText("Off");
            i = i + 1
            Turbine.Shell.WriteLine(i)

        elseif i == 1 then
            vitalButton:SetText("Auto");
            i = i + 1
            Turbine.Shell.WriteLine(i)
            
            player.InCombatChanged = function(sender, args)
                if player:IsInCombat() == true then
                    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, true );
                else
                    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, false );
                end            
            end

        elseif i == 2 then
            vitalButton:SetText("Inv");
            i = i + 1
            Turbine.Shell.WriteLine(i)
            Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, true );
            player.InCombatChanged = function(sender, args)
                if player:IsInCombat() == true then
                    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, false );
                else
                    Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, true );
                end            
            end

        else
            Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, true );
            vitalButton:SetText("On");
            i = 0;
            Turbine.Shell.WriteLine(i)
        end
    end

    -- add a label for load/unload original targetbar
    local targetLabel = Turbine.UI.Label();
    targetLabel:SetParent(options);
    targetLabel:SetSize(200, 25);
    targetLabel:SetPosition(10, 70);
    targetLabel:SetText("Targetbar Switch: ");

    local targetButton = Turbine.UI.Lotro.Button()
    targetButton:SetParent(options);
    targetButton:SetSize(30, 15);
    targetButton:SetPosition(10, 90);
    targetButton:SetVisible(true);
    targetButton:SetText("On");
    local i = 0;
    targetButton.Click = function(sender, args)
        if i == 0 then
            Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, false );
            targetButton:SetText("Off");
            i = i + 1
        else
            Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Target, true );
            targetButton:SetText("On");
            i = 0;
        end
    end

    -- add a label for load/unload original vitalbar
    local hightfromgroundLabel = Turbine.UI.Label();
    hightfromgroundLabel:SetParent(options);
    hightfromgroundLabel:SetSize(200, 25);
    hightfromgroundLabel:SetPosition(10, 130);
    hightfromgroundLabel:SetText("Set hight from Ground: ");

    local hightfromgroundScrollBar = Turbine.UI.Lotro.ScrollBar()
    hightfromgroundScrollBar:SetParent(options);
    hightfromgroundScrollBar:SetSize(200, 15);
    hightfromgroundScrollBar:SetPosition(10, 150);
    hightfromgroundScrollBar:SetVisible(true);
    --hightfromgroundScrollBar:SetText("On");
    hightfromgroundScrollBar.ValueChanged = function(sender, args)
        local value = hightfromgroundScrollBar:GetValue() / 100;        
        window:SetPosition(screenWidth/2 - width/2, screenHeight * value);
        hightfromgroundLabel:SetText("Set hight from Ground: " .. value);
    end
end

function Main()
    DrawOptionsControl();
end

Main();